//---------------------------------------------
// Example program to test some TCP functions in C# and .NET
// Bill Nolde 2002
// billnolde@ieee.org
//-------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;


namespace WebPageGet
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form 
	{
		[DllImport("user32.dll")]
		public static extern bool  MessageBeep(int Sound);
		[DllImport("user32.dll")]
		public static extern int   MessageBox(int hWnd, String text, 
			String caption, uint type);

		private string url_to_lookup;


		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox m_results;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.ListBox m_url_list;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox m_http_header;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox m_urls;
		private System.Windows.Forms.Button GetButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_http_header.Text = "GET /"  + " HTTP/1.1\r\nConnection: Keep-Alive\r\nHost: a.b.com" +"\r\n\r\n";
			GetButton.Select();		//make default button
			GetButton.Focus();
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			this.button1 = new System.Windows.Forms.Button();
			this.GetButton = new System.Windows.Forms.Button();
			this.m_results = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.button3 = new System.Windows.Forms.Button();
			this.m_url_list = new System.Windows.Forms.ListBox();
			this.label3 = new System.Windows.Forms.Label();
			this.m_http_header = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.m_urls = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(736, 8);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "Exit";
			this.button1.Click += new System.EventHandler(this.ExitButtonClick);
			// 
			// GetButton
			// 
			this.GetButton.Location = new System.Drawing.Point(736, 88);
			this.GetButton.Name = "GetButton";
			this.GetButton.TabIndex = 1;
			this.GetButton.Text = "Get";
			this.GetButton.Click += new System.EventHandler(this.GetButtonClick);
			// 
			// m_results
			// 
			this.m_results.AcceptsReturn = true;
			this.m_results.AcceptsTab = true;
			this.m_results.Location = new System.Drawing.Point(-8, 144);
			this.m_results.MaxLength = 128000;
			this.m_results.Multiline = true;
			this.m_results.Name = "m_results";
			this.m_results.ReadOnly = true;
			this.m_results.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.m_results.Size = new System.Drawing.Size(624, 256);
			this.m_results.TabIndex = 0;
			this.m_results.TabStop = false;
			this.m_results.Text = "";
			this.m_results.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.m_results.WordWrap = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(312, 8);
			this.label1.Name = "label1";
			this.label1.TabIndex = 4;
			this.label1.Text = "URL to get";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(328, 112);
			this.label2.Name = "label2";
			this.label2.TabIndex = 5;
			this.label2.Text = "Results";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(736, 48);
			this.button3.Name = "button3";
			this.button3.TabIndex = 0;
			this.button3.TabStop = false;
			this.button3.Text = "About";
			this.button3.Click += new System.EventHandler(this.AboutButtonClick);
			// 
			// m_url_list
			// 
			this.m_url_list.AccessibleDescription = ((string)(configurationAppSettings.GetValue("m_url_list.AccessibleDescription", typeof(string))));
			this.m_url_list.AllowDrop = true;
			this.m_url_list.HorizontalScrollbar = true;
			this.m_url_list.ItemHeight = 16;
			this.m_url_list.Location = new System.Drawing.Point(664, 184);
			this.m_url_list.Name = "m_url_list";
			this.m_url_list.Size = new System.Drawing.Size(272, 212);
			this.m_url_list.TabIndex = 0;
			this.m_url_list.TabStop = false;
			this.m_url_list.SelectedIndexChanged += new System.EventHandler(this.m_url_list_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(720, 152);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(168, 23);
			this.label3.TabIndex = 9;
			this.label3.Text = "Hosts referenced in Page";
			// 
			// m_http_header
			// 
			this.m_http_header.Location = new System.Drawing.Point(40, 80);
			this.m_http_header.Name = "m_http_header";
			this.m_http_header.Size = new System.Drawing.Size(632, 22);
			this.m_http_header.TabIndex = 0;
			this.m_http_header.TabStop = false;
			this.m_http_header.Text = "";
			this.m_http_header.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(320, 64);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(100, 16);
			this.label4.TabIndex = 11;
			this.label4.Text = "HTTP Header";
			// 
			// m_urls
			// 
			this.m_urls.Location = new System.Drawing.Point(136, 32);
			this.m_urls.Name = "m_urls";
			this.m_urls.Size = new System.Drawing.Size(456, 24);
			this.m_urls.TabIndex = 14;
			this.m_urls.TabStop = false;
			this.m_urls.Text = "http://www.codeguru.com";
			this.m_urls.SelectedIndexChanged += new System.EventHandler(this.m_urls_SelectedIndexChanged);
			// 
			// Form1
			// 
			this.AcceptButton = this.GetButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(944, 415);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.m_urls,
																		  this.label4,
																		  this.m_http_header,
																		  this.label3,
																		  this.m_url_list,
																		  this.button3,
																		  this.label2,
																		  this.label1,
																		  this.m_results,
																		  this.GetButton,
																		  this.button1});
			this.Name = "Form1";
			this.Text = "TcpClient Web Request example 2002  Bill Nolde";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
//-------------------------------------------------------------------
private void ExitButtonClick(object sender, System.EventArgs e)
{
	Application.Exit();	
}
//----------------------------------------------------------------------
private void AboutButtonClick(object sender, System.EventArgs e)
{
	MessageBox(0,"Web Page Get Example in C#" +
		"\n      for the .NET Framework" +
		"\n              Bill Nolde" +
		"\n        billnolde@ieee.org","",0);
}
//----------------------------------------------------------------------
private void GetButtonClick(object sender, System.EventArgs e)
{	

	url_to_lookup = m_urls.Text;
	bool got_page = GoGetIt();
	if (got_page == false) {
		return;
	}
try {
	m_urls.Text = url_to_lookup;
	if (m_urls.FindStringExact(url_to_lookup,-1) != -1) return;  //already in list
	m_urls.Items.Insert(0, url_to_lookup);
} catch(Exception except ) {
	m_results.Text = except.ToString();
}

}
//-------------------------------------------------------------------
//This procedure is invoked by clicking on a hostname in the URLs in Page box
private void m_url_list_SelectedIndexChanged(object sender, System.EventArgs e)
{

try {
	int sDx = m_url_list.SelectedIndex;
	m_urls.Text = m_url_list.Items[sDx].ToString();			//get hostname selected
	bool got_page = GoGetIt();
	if (got_page == false) return;							//a  network error
	if (m_urls.FindStringExact(m_urls.Text,-1) != -1) return; //already in list
	m_urls.Items.Insert(0, m_urls.Text);
} catch(Exception except ) {
	m_results.Text = except.ToString();
}

}
//-------------------------------------------------------------------
//This procedure is invoked by clicking on a hostname in the URL looked up list 
private void m_urls_SelectedIndexChanged(object sender, System.EventArgs e)
{
	m_urls.Text = m_urls.SelectedItem.ToString();		//get hostname selected
	bool got_page = GoGetIt();
	return;
}
//----------------------------------------------------------------------
//This is the main routine for retrieving the contents of a web page
// and displaying both the page itself plus all hostnames embedded in it.
private bool GoGetIt()
{
String host="", path="",  page = "";

	MessageBeep(16);
	String Tstring = m_urls.Text.ToLower();
	if (Tstring.StartsWith("http://") != true)
		m_urls.Text = "http://" + m_urls.Text;
	GetHostAndPath(m_urls.Text, ref host, ref path);
	bool ReturnValue = GetWebPage(host, path,ref page,80);
	m_results.Text = page;
	MessageBeep(32);
	GetHosts(page);
	return ReturnValue;		
}
//--------------------------------------------------------------------
//This is a lower level  function that uses the TcpClient and NetworkStream
// classes to retrieve a web page from a remote host.
bool GetWebPage(String Host, String Path, ref String Page, int Port)
{
NetworkStream ns;
byte[] bytes;	
ASCIIEncoding ASCII = new ASCIIEncoding();

	TcpClient tc = new TcpClient();
	try
	{ 
		tc.Connect(Host, Port);
		ns = tc.GetStream();
		if(ns.CanWrite && ns.CanRead)	{
			tc.ReceiveBufferSize = 128000;

			// Create http GET string. Modify for other options as necessary.
			Byte[] sendBytes = Encoding.ASCII.GetBytes(m_http_header.Text);
			ns.Write(sendBytes, 0, sendBytes.Length);
      
			// Reads the NetworkStream into a byte buffer.
			bytes = new byte[tc.ReceiveBufferSize];
			int numBytesRead = 0;
			int numBytesToRead =  tc.ReceiveBufferSize;

			while (true)	{
				int n = ns.Read(bytes, numBytesRead, numBytesToRead );
				if (n==0) break;
				numBytesRead += n;
				numBytesToRead -= n;
				Thread.Sleep (1000);		//wait a little, just in case
				if( ns.DataAvailable != true)break;
			}
			tc.Close();
			Page = ASCII.GetString(bytes);
			ChangeLfToCrLf(ref Page);
		}
	}
	catch (Exception except ) 
	{
		Page = except.ToString();
		tc.Close();
		return false;
	}
	return true;
}
//-------------------------------------------------------------
//This function is needed because some web pages us <cr><lf>, some just <lf>
// Some, like CNN has both types in pages as well as 2 sets in a row
void ChangeLfToCrLf ( ref String buf)
{
byte[] abuf = new byte[256000];
int abuf_index = 0;
ASCIIEncoding ASCII = new ASCIIEncoding();

	int crCount = buf.IndexOf("\r",0);
	if (crCount == -1) 	{				// No carriage returns
		buf = buf.Replace("\x0a", "\x0d\x0a");
		return;
	}
	int bufsize = buf.Length;
	for(int i=0; i<bufsize-1; i++) 	{
		char ch		=	buf[i];
		char nextch =	buf[i+1];
		if (ch == '\n') {
			if (nextch != '\r') 
			{
					abuf[abuf_index++] = (byte) '\r';
					abuf[abuf_index++] = (byte) '\n';
			}
			else 	abuf[abuf_index++] = (byte) '\n';
		}
		else		abuf[abuf_index++] = (byte)  ch;
	}
	buf = ASCII.GetString((byte[]) abuf);
}
//----------------------------------------------------------------------
//this procedure uses th URI class (uniform resource identifier) to break out
//the hostname from the rest of the URL
void GetHostAndPath( String uri, ref String Hostname, ref String Path)
{
try {
	Uri siteUri = new Uri(uri );
	Hostname	= siteUri.Host;
	Path		= siteUri.AbsolutePath;
} 
catch{}
}
//----------------------------------------------------------------------
//this procedure searches the page for "http://" to look for host names
public void GetHosts (String page)
{
	try
	{ 
	String Tstring = page.ToLower();
	m_url_list.Items.Clear();
	int sDx = 0;
	char[] chTerminators = new char[6];
	chTerminators[0] = '/';
	chTerminators[1] = '\'';
	chTerminators[2] = '"';
	chTerminators[3] = ' ';
	chTerminators[4] = '\t';
	chTerminators[5] = '\n';

	while(true) {
		sDx = Tstring.IndexOf("http://",sDx);
		if (sDx == -1) break;
		int nDx   = Tstring.IndexOfAny(chTerminators,sDx+8);
		String ts = Tstring.Substring(sDx, nDx-sDx);
		if (m_url_list.FindString(ts)== ListBox.NoMatches)
			m_url_list.Items.Add(ts);
		sDx = nDx;
	}
}	
catch 	{}		//ignore
}
//---------------------------------------------------------------------
	}   //end class
}		//end namespace
